// Multi Agents Frame
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.awt.Cursor;
import javax.swing.UIManager;
import javax.swing.plaf.basic.BasicTabbedPaneUI;
import javax.swing.table.*;

class MAFrame extends JFrame{
    
    Dimension dim = getToolkit().getScreenSize();
    private int dimW, dimH;
    private ActionHandler actionHandler;
    private MAmenubar menu;
    void frameSet() {
        dimW = dim.width;       // realscreen Width-size
        dimH = dim.height;      // realscreen Height-size
        
        // exit event
        this.addWindowListener(new WindowAdapter()
        {
            public void windowClosing(WindowEvent we)
            {
                System.exit(0);
            }
        });
    }
    
    private Container con;
    private JLabel l_logo = new JLabel("Client Agent", JLabel.CENTER);
    private JLabel l_detail = new JLabel("Dept. of Computer Information Engineering, Kunsan National University", JLabel.RIGHT);
    
    private JButton b_reg = new JButton("register");
    private JButton b_search = new JButton("Search");
    
    private JPanel pn_left = new JPanel();//new BorderLayout());
    private JPanel pn_center = new JPanel(new GridLayout());
    
    private JTextField t_sc = new JTextField();
    
    private CheckboxGroup cbg = new CheckboxGroup(); 
    private Checkbox cb_all, cb_sds, cb_spa;
    private GridBagLayout gbl;
    private MyTableModel tablemodel = new MyTableModel();
    private JTable Dbtable = new JTable(tablemodel);
        
    // Tab
    private JTabbedPane jtp = new JTabbedPane(JTabbedPane.TOP, JTabbedPane.SCROLL_TAB_LAYOUT);
    private JLabel tlb1 = new JLabel("ù° Tab", JLabel.CENTER);
    private JLabel tlb2 = new JLabel("ι° Tab", JLabel.CENTER);
    private JLabel tlb3 = new JLabel("° Tab", JLabel.CENTER);
    private JLabel tlb4 = new JLabel("׹° Tab", JLabel.CENTER);
    private JLabel emptyLabel = new JLabel(" ",JLabel.CENTER);
    
    MAFrame() {
        init();
    }
    
    private void init() {
        /*** Logo ***/
        con = this.getContentPane();
        con.setLayout(new BorderLayout(5, 5));
        l_detail.setFont(new Font("",Font.ITALIC ,12));
        con.add("North", l_logo);
        con.add("South", l_detail);
        
        /*** Panel Left ***/
        cb_all = new Checkbox("All", cbg, true);
        cb_sds = new Checkbox("SensorDataServer ", cbg, false);
        cb_spa = new Checkbox("ServerPushAgent", cbg, false);
        gbl= new GridBagLayout();
        pn_left.setLayout(gbl);
        pn_left.add(addTo(b_reg,0,0,1,1));
        pn_left.add(addTo(t_sc,0,1,1,1));
        pn_left.add(addTo(cb_all,0,2,1,1));
        pn_left.add(addTo(cb_sds,0,3,1,1));
        pn_left.add(addTo(cb_spa,0,4,1,1));
        pn_left.add(addTo(b_search,0,5,1,1));
        this.pack();
        //pn_left.add(b_reg);
        //pn_left.add(t_sc);
        //pn_left.add(cb_all);
        //pn_left.add(cb_sds);
        //pn_left.add(cb_spa);
        //pn_left.add(b_search);
        
        
        con.add("West", pn_left);
        
        /*** Panel Center ***/
        jtp.setUI(new UI());
        JScrollPane jpane = new JScrollPane(Dbtable);
        jtp.add("SENSOR DATA", jpane);     //1 
        jtp.add("Result", tlb2);               //2 
        jtp.add("Chart", tlb3);                   //3 
        pn_center.add("Center", jtp);
        
        con.add("Center", pn_center);
        
        actionHandler = new ActionHandler(b_search,b_reg,t_sc,cbg,jtp);
        b_search.addActionListener(actionHandler);
        b_reg.addActionListener(actionHandler);
        
        
        //pn_left.add(jpane);
        //jpanel.add(jpanel1);
        
        //Dbtable.setAutoCreateColumnsFromModel(true);
        //Dbtable.setAutoResizeMode(JTable.AUTO_RESIZE_ALL_COLUMNS);
        //Dbtable.setVisible(true);
        //Dbtable.setSize(500,300);
    }
    
    public void setDbTable(String table_name)
    {
        //tablemodel.setResultSet(controldb.getTable(table_name));
    }

    private Component addTo(Component com,  int x, int y, int grid_x, int grid_y){
        GridBagConstraints gbc = new GridBagConstraints();
        gbc.fill = GridBagConstraints.BOTH;
        gbc.gridx =  x;
        gbc.gridy = y;
        gbc.gridwidth = grid_x;
        gbc.gridheight = grid_y;
        
        this.gbl.setConstraints(com,gbc); 
        return com;
    }


    
    // Frame position
    void setPosition() {
        //this.setLocation((dimW / 2) - 350, 0);
    }

    // Main
    /*public static void main(String[] args) {
        MAFrame maFrame = new MAFrame();
        maFrame.frameSet();
        maFrame.setSize(1200, 800);
        maFrame.setResizable(false);
        maFrame.setTitle("Multi Agent system");
        maFrame.setPosition();
        maFrame.show();
    }*/

}

class UI extends BasicTabbedPaneUI
{
    //@Override
    protected void paintTabBorder(Graphics g, int tabPlacement, int tabIndex, int x, int y, int w, int h, boolean isSelected) {
        // TODO Auto-generated method stub
        g.setColor(Color.white);
        g.drawRoundRect(x, y, w, h, 5, 5);
        if (isSelected)
        {
            g.setColor(Color.red);
            g.drawLine(x+4 , h ,  x+w-4 , h);
        }
    }
}
