
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.awt.Cursor;
import javax.swing.UIManager;
import javax.swing.plaf.basic.BasicTabbedPaneUI;
import javax.swing.table.*;
import javax.swing.JFormattedTextField;
import javax.swing.text.MaskFormatter;
import java.text.NumberFormat;
import java.net.*;

class MAFrame extends JFrame{
    
    Dimension dim = getToolkit().getScreenSize();
    private int dimW, dimH;
    private ActionHandler actionHandler;
    private MAmenubar menu;
    private void frameSet() {
        dimW = dim.width;       // realscreen Width-size
        dimH = dim.height;      // realscreen Height-size
        
        // exit event
        this.addWindowListener(new WindowAdapter()
        {
            public void windowClosing(WindowEvent we)
            {
                System.exit(0);
            }
        });
    }
    
    private Container con;
    private Dialog d_reg, d_add;
    private Frame f_reg = new Frame("Naming Register");
    
    private JLabel l_nameReg = new JLabel("Naming Register",JLabel.CENTER);
    private JLabel l_name = new JLabel("Name",JLabel.RIGHT);
    private JLabel l_url = new JLabel("URL",JLabel.RIGHT);    
    private JLabel l_key = new JLabel("Keyword",JLabel.RIGHT);
    private JLabel l_logo = new JLabel("Server Agent", JLabel.CENTER);
    private JLabel l_detail = new JLabel("Dept. of Computer Information Engineering, Kunsan National University", JLabel.RIGHT);
    private JLabel l_addData = new JLabel("Add Data",JLabel.CENTER);
    private JLabel l_addColm1 = new JLabel("Column 1 ",JLabel.RIGHT);
    private JLabel l_addColm2 = new JLabel("Column 2 ",JLabel.RIGHT);
    private JLabel l_addColm3 = new JLabel("Column 3 ",JLabel.RIGHT);
    
//    private JFormattedTextField t_name;
//    private JFormattedTextField t_url;
//    private JFormattedTextField t_key;
    
    private JTextField t_name;
    private JTextField t_url;
    private JTextField t_key;
    
    private JTextField t_addColm1 = new JTextField("",30);
    private JTextField t_addColm2 = new JTextField("",30);
    private JTextField t_addColm3 = new JTextField("",30);
    
    private JTextArea ta_log = new JTextArea("// Log //\n");
    
    private JButton b_reg = new JButton("register");
    private JButton b_add = new JButton("input Data");
    private JButton b_remove = new JButton("remove Data");
    private JButton b_ok = new JButton("OK");
    
    private JPanel pn_up = new JPanel(new BorderLayout(5, 5));
    private JPanel pn_left = new JPanel();//(new GridBagLayout());
    private JPanel pn_center = new JPanel(new BorderLayout());
    
    private MyTableModel tablemodel = new MyTableModel();
    private JTable Dbtable = new JTable(tablemodel);
    private JTable rqtable = new JTable(tablemodel);
    
    private Checkbox cb1;
    private Checkbox cb2;    
    
    // Tab
    private JTabbedPane jtp = new JTabbedPane(JTabbedPane.TOP, JTabbedPane.SCROLL_TAB_LAYOUT);
    
    MAFrame() {
        init();
    }
    
    private void init() {
        /*** Logo ***/
        con = this.getContentPane();
        con.setLayout(new BorderLayout(5, 5));
        l_detail.setFont(new Font("",Font.ITALIC ,12));
        pn_up.add("North", l_logo);
        pn_up.add("West", b_add);
        pn_up.add("East", b_remove);
        
        con.add("North", pn_up);
        con.add("South", l_detail);
        
        /*** Panel Center ***/
        jtp.setUI(new UI());
        JScrollPane sp_Db = new JScrollPane(Dbtable);
        JScrollPane sp_Rq = new JScrollPane(rqtable);
        //JScrollPane jpane1 = new JScrollPane(Dbtable);
        jtp.add("table state", sp_Db);
        jtp.add("request Data",sp_Rq);
        jtp.add("system log",ta_log);
        pn_center.add("Center", jtp);
        
        /*** JFormattedTextField Setting ***/
        /*try{
            t_name = new JFormattedTextField();
            t_url = new JFormattedTextField(getIP());
            t_key = new JFormattedTextField();
            //t_url.setText("rmi://"+getIP());
        }
        catch(java.text.ParseException exc) {
            // handle exception
        }
        catch(Exception e) {
            e.printStackTrace();
        }*/
        
        
        t_name = new JTextField();
        t_key = new JTextField();
        try{
        	t_url = new JTextField(getIP());
        }catch(Exception e){
        	e.printStackTrace();
        }     
        
        /*** register_Dialog Setting ***/        
        d_reg = new Dialog(this, "Register to Naming Agent", true);
        CheckboxGroup group = new CheckboxGroup();
        cb1 = new Checkbox("ServerPushAgent", group, true);        
        cb2 = new Checkbox("SensorDataServer", group, false);
        d_reg.setLayout(new GridLayout(5,2));
        d_reg.setLocation(500,300);
        d_reg.setSize(300,150);
        d_reg.add(l_name);
        d_reg.add(t_name);
        d_reg.add(l_url);
        d_reg.add(t_url);
        d_reg.add(l_key);
        d_reg.add(t_key);
        d_reg.add(cb1);
        d_reg.add(cb2);
        d_reg.add(l_nameReg);
        d_reg.add(b_reg);
        
        /*** addData_Dialog Setting ***/
        d_add = new Dialog(this, "Add Data to Table", true);
        d_add.setLayout(new GridLayout(4,2));
        d_add.setLocation(500,300);
        d_add.setSize(300,150);
        d_add.add(l_addColm1);
        d_add.add(t_addColm1);
        d_add.add(l_addColm2);
        d_add.add(t_addColm2);
        d_add.add(l_addColm3);
        d_add.add(t_addColm3);
        d_add.add(l_addData);
        d_add.add(b_ok);
        d_add.addWindowListener(new WindowAdapter()
        {
            public void windowClosing(WindowEvent we)
            {
                d_add.setVisible(false);
                t_addColm1.setText("");
                t_addColm2.setText("");
                t_addColm3.setText("");
            }
        });
        
        con.add("Center", pn_center);
        actionHandler = new ActionHandler(d_reg, d_add, Dbtable, rqtable, b_reg, b_add, b_remove, b_ok, jtp, t_addColm1, t_addColm2, t_addColm3, ta_log, t_name, t_url, t_key);
        
        /*** addLister ***/
        b_reg.addActionListener(actionHandler);
        b_add.addActionListener(actionHandler);
        b_remove.addActionListener(actionHandler);
        b_ok.addActionListener(actionHandler);
        Dbtable.addMouseListener(actionHandler);
        
        Dbtable.setAutoCreateColumnsFromModel(true);
        Dbtable.setAutoResizeMode(JTable.AUTO_RESIZE_ALL_COLUMNS);
        Dbtable.setSelectionMode(1);
        Dbtable.setVisible(true);
        //Dbtable.setSize(500,300);
        
        this.frameSet();
        this.setSize(1200, 800);
        this.setResizable(false);
        this.setTitle("Multi Agent system");
        this.setPosition();
        this.setVisible(true);
        d_reg.setResizable(false);
        d_reg.setVisible(true);
        d_add.setResizable(false);
        d_add.setVisible(false);

        //dl.add(f_reg);
    }
    
    public void setDbTable(String table_name)
    {
        //tablemodel.setResultSet(controldb.getTable(table_name));
    }

    private Component addTo(Component com,  int x, int y, int grid_x, int grid_y){
        GridBagConstraints gbc = new GridBagConstraints();
        gbc.fill = GridBagConstraints.BOTH;
        gbc.gridx =  x;
        gbc.gridy = y;
        gbc.gridwidth = grid_x;
        gbc.gridheight = grid_y;
        
        //gbl.setConstraints(com,gbc); 
        return com;
    }

    
    // Frame position
    private void setPosition() {
        //this.setLocation((dimW / 2) - 350, 0);
    }
    
    private String getIP() throws Exception{
        InetAddress[] local = InetAddress.getAllByName(InetAddress.getLocalHost().getHostName());
        String IP = (String)local[0].getHostAddress();
        System.out.println(IP);
        ta_log.append(IP+"\n");
        return IP;
    }
    
    // Main
    /*public static void main(String[] args) throws Exception{
        MAFrame maFrame = new MAFrame();
        
    }*/
}

class UI extends BasicTabbedPaneUI
{
    //@Override
    protected void paintTabBorder(Graphics g, int tabPlacement, int tabIndex, int x, int y, int w, int h, boolean isSelected) {
        // TODO Auto-generated method stub
        g.setColor(Color.white);
        g.drawRoundRect(x, y, w, h, 5, 5);
        if (isSelected)
        {
            g.setColor(Color.red);
            g.drawLine(x+4 , h ,  x+w-4 , h);
        }
    }
}
