
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.awt.Cursor;
import javax.swing.UIManager;
import javax.swing.plaf.basic.BasicTabbedPaneUI;
import javax.swing.table.*;

class MAFrame extends JFrame{
    
    Dimension dim = getToolkit().getScreenSize();
    private int dimW, dimH;
    private ActionHandler actionHandler;
    private MAmenubar menu;
        
    private Container con;
    private JLabel logoL = new JLabel("Naming Agent", JLabel.CENTER);
    private JLabel detailL = new JLabel("Dept. of Computer Information Engineering, Kunsan National University", JLabel.RIGHT);
    private JLabel metaL = new JLabel("Metadata",JLabel.LEFT);
    private JLabel subL = new JLabel("Subdata",JLabel.LEFT);
    
    private JTextField tf_sc = new JTextField(20);
    
    private JPanel pn_center = new JPanel(new GridLayout(2,1));
    private JPanel pn_North = new JPanel(new BorderLayout(10,2));
    private JPanel pn_Center = new JPanel(new BorderLayout(10,2));
    private JPanel bottomIn = new JPanel();
    private MainTableModel mainmodel = new MainTableModel();
    private JTable metadata = new JTable(mainmodel);
    private SDSTableModel sdsmodel = new SDSTableModel();
    private JTable subdata = new JTable(sdsmodel);
    
    java.util.List<String> a;
    java.util.List<String> b;
    java.util.List<String> c;
    java.util.List<String> d;
    
    TableUtil tableUtil;
    String[][] copyTable;
    private void frameSet() {
        dimW = dim.width;       // realscreen Width-size
        dimH = dim.height;      // realscreen Height-size
        
        // exit event
        this.addWindowListener(new WindowAdapter()
        {
            public void windowClosing(WindowEvent we)
            {
                System.exit(0);
            }
        });
    }
    
    MAFrame() {
        init();                
    }
        
    public void updateTable(){
    	copyTable = tableUtil.getNameTable();
        mainmodel.setResultSet(copyTable);
    	pn_North.updateUI();
    	//pn_North.repaint();   	
    }
    
    private void init() {
        /*** Logo ***/
        con = this.getContentPane();
        con.setLayout(new BorderLayout(5,5));
        detailL.setFont(new Font("",Font.ITALIC ,12));
        con.add("North", logoL);
        con.add("South", detailL);

        /*** Panel Center ***/
        tableUtil = new TableUtil();
        a = new ArrayList<String>();
        b = new ArrayList<String>();
        c = new ArrayList<String>();
        d = new ArrayList<String>();
            
        copyTable = tableUtil.getNameTable();
        mainmodel.setResultSet(copyTable);
        
        /*for(int i = 0; i<copyTable.length; i++){
        	a.add(copyTable[i][0]);
        	b.add(copyTable[i][1]);
        	c.add(copyTable[i][2]);
        	d.add(copyTable[i][3]);
        }*/
        //mainmodel.setResultSet(a,b,c,d); 
                
        // metadata
        JScrollPane jpane = new JScrollPane(metadata);
        
        pn_North.add("North",metaL);
        pn_North.add("Center",jpane);
        
        // subdata
        JScrollPane jpane1 = new JScrollPane(subdata);
        pn_Center.add("North",subL);
        pn_Center.add("Center",jpane1);
        
        
        pn_center.add(pn_North);
        pn_center.add(pn_Center);
        
        con.add("Center", pn_center);
        
        actionHandler = new ActionHandler(metadata, subdata);
        metadata.addMouseListener(actionHandler);
        metadata.setAutoCreateColumnsFromModel(true);
        metadata.setAutoResizeMode(JTable.AUTO_RESIZE_ALL_COLUMNS);
        subdata.setAutoCreateColumnsFromModel(true);
        subdata.setAutoResizeMode(JTable.AUTO_RESIZE_ALL_COLUMNS);
        
        this.frameSet();
        this.setSize(1200, 800);
        this.setResizable(false);
        this.setTitle("Multi Agent system");
        //this.setPosition();
        this.setVisible(true);
                     
    }
 
    // Main
    /*public static void main(String[] args) {
        MAFrame maFrame = new MAFrame();
        maFrame.frameSet();
        maFrame.setSize(1200, 800);
        maFrame.setResizable(false);
        maFrame.setTitle("Multi Agent system");
        maFrame.show();
    }*/

}
