
import java.util.*;
import javax.swing.*;
import javax.swing.table.*;

class MyTableModel extends AbstractTableModel {
    
    Object[][] data, newdata, olddata;
    String[] columnNames = { "Num", "Title", "Contents" };
    int columnsize = columnNames.length;
    int rows;
    
    MyTableModel(){
    }
    
    public void setResultSet(java.util.List a, java.util.List b, java.util.List c) {

        resetTable();
                
        rows = b.size();        
        data = new Object[rows][columnsize];
        for(int i=0; i<rows;i++)
        {
            data[i][0] = a.get(i);
            data[i][1] = b.get(i);
            data[i][2] = c.get(i);
        }
        fireTableChanged(null);
    }

    public void resetTable() {
        try
        {
            fireTableChanged(null);
        } catch(NullPointerException npe) {}
    }
 
    public String getColumnName(int column)
    {
        return columnNames[column] == null ?"No Name" : columnNames[column];
    }
    
    public int getColumnCount() {
        return columnNames.length;
    }
    
    public int getRowCount()
    {
        if(data == null) return 0;
        else return data.length;
    }
    
    public Object getValueAt(int row, int col) {
        return data[row][col];
    }
    
    public Class getColumnClass(int c) {
        return getValueAt(0, c).getClass();
    }
    
    public TableModel removeRow(int row) {
        
        // last table row
        if(row==(rows-1)) {
            newdata = new Object[rows-1][columnsize];
            for(int i=0; i<rows-1; i++) {
                for(int k=0; k<columnsize; k++) {
                    newdata[i][k]=data[i][k];
                }
            }
            data=newdata;
            rows--;
        }
        else {
            newdata = new Object[rows-1][columnsize];
            
            for(int i=row; i<rows-1; i++) {
                for(int k=0; k<columnsize; k++) {
                    data[i][k]=data[i+1][k];
                    //System.out.println("data["+i+"]["+k+"]="+data[i][k]);
                }
            }
            for(int i=0; i<rows-1; i++) {
                for(int k=0; k<columnsize; k++) {
                    newdata[i][k]=data[i][k];
                    //System.out.println("data["+i+"]["+k+"]="+data[i][k]);
                }
            }
            data=newdata;
            rows--;
        }
        System.out.println("Row count : " + rows + "row");
        return this;
    }
}
